<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\ApontamentoService;

class ApontamentoController extends FMCrud{
    
    protected $ApontamentoService;
   
    public function __construct($crudService, $environment, ApontamentoService $ApontamentoService) {
        parent::__construct($crudService, $environment);
        $this->ApontamentoService = $ApontamentoService;
    }
    
    public function getDadosCardApontamento(DTO\Request $request, DTO\Response $response) {
      $parametro = $request->getParameters();
      $pesquisaApontamentos = $this->ApontamentoService->getDadosCardApontamento($parametro);
      $dtsVal = new DataSet('dados',  $pesquisaApontamentos);
      $response->addDataSet($dtsVal);
    }
    
    public function getDadosApontamentoInserido(DTO\Request $request, DTO\Response $response) {
      $parametro = $request->getParameters();
      
      $pesquisaApontamentos = $this->ApontamentoService->getDadosApontamentoInserido($parametro);
      $dtsVal = new DataSet('dados',  $pesquisaApontamentos);
      $response->addDataSet($dtsVal);
    }
    
    public function buscaRegistrosHora(DTO\Request $request, DTO\Response $response) {
      $parametro = $request->getParameters();
      $pesquisaRegistro = $this->ApontamentoService->buscaRegistrosHora($parametro);
      $dtsVal = new DataSet('dados',  $pesquisaRegistro);
      $response->addDataSet($dtsVal);
    }
    
    public function insertNovoApontamento(DTO\Request $request, DTO\Response $response) {
      $parametro = $request->getParameters();
      $insAp = $this->ApontamentoService->insertNovoApontamento($parametro);
      $dtsVal = new DataSet('dados', array('retorno' => $insAp));
      $response->addDataSet($dtsVal);
    }
    
    public function deleteRegistroHoras(DTO\Request $request, DTO\Response $response) {
      $parametro = $request->getParameters();
      $delete = $this->ApontamentoService->deleteRegistroHoras($parametro);
      $dtsVal = new DataSet('dados', array('retorno' => $delete));
      $response->addDataSet($dtsVal);
    }
    
    public function apurarHoras(DTO\Request $request, DTO\Response $response) {
      $parametro = $request->getParameters();
      $retornoApuracao = $this->ApontamentoService->apurarHoras($parametro);
      $dtsVal = new DataSet('dados',  array('retorno' => $retornoApuracao));
      $response->addDataSet($dtsVal);
    }
    
    public function getDadosDocEObservacoes(DTO\Request $request, DTO\Response $response) {
      $parametro = $request->getParameters();
      $retornoObservacoes = $this->ApontamentoService->getDadosDocEObservacoes($parametro);
      $dtsVal = new DataSet('dados',  $retornoObservacoes);
      $response->addDataSet($dtsVal);
    }
    
  }
?>