<?php

namespace FM\Service;

use FM\Factory\ApontamentoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class ApontamentoService {
    protected $ApontamentoFactory;
    protected $Environment;
    protected $newCode;
    
    public function __construct (ApontamentoFactory $ApontamentoFactory, Environment $Environment, NewCode $newCode) {
        $this->ApontamentoFactory  = $ApontamentoFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
    }
    
    public function getDadosCardApontamento($param){

        $parametroConsulta = '';
        if($param["NRFUNCIONARIO"] === "" && $param["NRSETOR"] === "" && sizeOf($param["DTULTATU"]) === 0) {
            
          $parametroConsulta = "";
          
        } else if($param["NRFUNCIONARIO"] !== "" && $param["NRSETOR"] !== "" && sizeOf($param["DTULTATU"]) > 0) {
            
            if (sizeOf($param["DTULTATU"]) === 1) {
                
                $data = strval($param["DTULTATU"][0]);
                $parametroConsulta = " WHERE AP.NRFUNCIONARIO = ".$param["NRFUNCIONARIO"]." AND REL.NRSETOR  = ".$param["NRSETOR"]."  AND TO_CHAR(AP.DTULTATU, 'DD/MM/YYYY') = TO_CHAR("."'".$data."'".")";
                
            } else {
                
                $dataInicio = strval($param["DTULTATU"][0]);
                $dataFim = strval($param["DTULTATU"][1]);
                $parametroConsulta = " WHERE AP.NRFUNCIONARIO = ".$param["NRFUNCIONARIO"]." AND REL.NRSETOR  = ".$param["NRSETOR"]."  AND TO_CHAR(AP.DTULTATU, 'DD/MM/YYYY') BETWEEN TO_CHAR("."'".$dataInicio."'".") AND TO_CHAR("."'".$dataFim."'".")"; 
            }
        } else if ($param["NRFUNCIONARIO"] !== "" && $param["NRSETOR"] === "" && sizeOf($param["DTULTATU"]) === 0) {
            
            $parametroConsulta = " WHERE AP.NRFUNCIONARIO = ".$param["NRFUNCIONARIO"]."";
            
        } else if ($param["NRFUNCIONARIO"] === "" && $param["NRSETOR"] !== "" && sizeOf($param["DTULTATU"]) === 0) {
            
            $parametroConsulta = " WHERE REL.NRSETOR  = ".$param["NRSETOR"]."";

        } else if ($param["NRFUNCIONARIO"] === "" && $param["NRSETOR"] === "" && sizeOf($param["DTULTATU"]) > 0) {
            
            if (sizeOf($param["DTULTATU"]) === 1) {
                
                $parametroConsulta = " AND TO_CHAR(AP.DTULTATU, 'DD/MM/YYYY') = TO_CHAR("."'".$param["DTULTATU"][0]."'".")";
            } else {
                
                $dataInicio = strval($param["DTULTATU"][0]);
                $dataFim = strval($param["DTULTATU"][1]);
                $parametroConsulta = " AND TO_CHAR(AP.DTULTATU, 'DD/MM/YYYY') BETWEEN TO_CHAR("."'".$dataInicio."'".") AND TO_CHAR("."'".$dataFim."'".")"; 
            }
        } else if ($param["NRFUNCIONARIO"] !== "" && $param["NRSETOR"] !== "" && sizeOf($param["DTULTATU"]) === 0) {
            
           $parametroConsulta = " WHERE AP.NRFUNCIONARIO = ".$param["NRFUNCIONARIO"]." AND REL.NRSETOR  = ".$param["NRSETOR"]."";
           
        } else if ($param["NRFUNCIONARIO"] !== "" && $param["NRSETOR"] === "" && sizeOf($param["DTULTATU"]) > 0) {
            
            if (sizeOf($param["DTULTATU"]) === 1) {
                
                $parametroConsulta = " WHERE AP.NRFUNCIONARIO = ".$param["NRFUNCIONARIO"]." AND TO_CHAR(AP.DTULTATU, 'DD/MM/YYYY') = TO_CHAR("."'".$param["DTULTATU"][0]."'".")";
            } else {
                
                $dataInicio = strval($param["DTULTATU"][0]);
                $dataFim = strval($param["DTULTATU"][1]);
                $parametroConsulta = " WHERE AP.NRFUNCIONARIO = ".$param["NRFUNCIONARIO"]."  AND TO_CHAR(AP.DTULTATU, 'DD/MM/YYYY') BETWEEN TO_CHAR("."'".$dataInicio."'".") AND TO_CHAR("."'".$dataFim."'".")"; 
            }
        } else if ($param["NRFUNCIONARIO"] === "" && $param["NRSETOR"] !== "" && sizeOf($param["DTULTATU"]) > 0) {
            
           if (sizeOf($param["DTULTATU"]) === 1) {
                
                $parametroConsulta = " WHERE AP.NRFUNCIONARIO = ".$param["NRFUNCIONARIO"]." AND REL.NRSETOR  = ".$param["NRSETOR"]." AND TO_CHAR(AP.DTULTATU, 'DD/MM/YYYY') = TO_CHAR("."'".$param["DTULTATU"][0]."'".")";
            } else {
                
                $dataInicio = strval($param["DTULTATU"][0]);
                $dataFim = strval($param["DTULTATU"][1]);
                $parametroConsulta = " WHERE AP.NRFUNCIONARIO = ".$param["NRFUNCIONARIO"]." AND REL.NRSETOR  = ".$param["NRSETOR"]."  AND TO_CHAR(AP.DTULTATU, 'DD/MM/YYYY') BETWEEN TO_CHAR("."'".$dataInicio."'".") AND TO_CHAR("."'".$dataFim."'".")"; 
            }
        }
        $dados = $this->ApontamentoFactory->getDadosCardApontamento($parametroConsulta);
        return $dados;
    }
    
    public function getDadosApontamentoInserido($param) {

        $nr = $param[0]["NRAPONTAMENTO"];
        $dtInclusao = $param[0]["DATA"];

        $dados = $this->ApontamentoFactory->getDadosApontamentoInserido($nr, $dtInclusao);
        return $dados;
    }
    
    public function getDadosDocEObservacoes($param) {

        $nr = array(
            "NRAPONTAMENTO" => $param[0],
        );
        $dados = $this->ApontamentoFactory->getDadosObservacoes($nr);
        return $dados;
    }
    
    public function buscaRegistrosHora($param) {
        $nfuncionario = $param["NRFUNCIONARIO"];

        $dados = $this->ApontamentoFactory->buscaRegistrosHora($nfuncionario);
        return $dados;
    }
    
    public function insertNovoApontamento($param){

        try {
            
            $NRORG = 20;
            
            forEach($param as $dados) {
                
                $paramentroConsultaApontamento = array(
                  "DTAPONTAMENTO" => $dados["data"],
                  "NRFUNCIONARIO" => $dados["funcionario"]
                );
                
                $consultaApontamento = $this->ApontamentoFactory->consultaApontamentoDia($paramentroConsultaApontamento);

                $codRegistroHoras = $this->newCode->getCodeByTableName("FCM_REGISTROHORAS", $NRORG, 1, 10, true);
                
                $nrApontamento = $this->newCode->getCodeByTableName("FCM_APONTAMENTO", $NRORG, 1, 10, true);
                
                if (sizeof($consultaApontamento) === 0){
                    
                    $dadosInsertApontamento = array(
                        "NRAPONTAMENTO" => $nrApontamento, 
                        "DTAPONTAMENTO" => $dados["data"], 
                        "NRFUNCIONARIO" => $dados["funcionario"], 
                        "HRENTRADA" => "", 
                        "HRSAIDA" => "", 
                        "HRINTERVALO" => "", 
                        "HRTRABALHADAS" => "", 
                        "HRAUSENCIA" => "", 
                        "HRTOTAIS" => "", 
                        "IDFALTA" => "N", 
                        "IDAPURADO" => "N", 
                        "NRORG" => $NRORG, 
                        "IDATIVO" =>  "S"
                    );
                     
                    $this->ApontamentoFactory->insertNovoApontamento($dadosInsertApontamento);
                     
                    $entrada = "";
                    $saida = "";
                    $idalmoco = "";
                    $tipo = "";
                     
                    if ($dados["tipoEntrada"] === "1") {
                        $entrada = "{$dados["data"]} {$dados["hora"]}";
                        $idalmoco = "N";
                        $tipo = "E";
                    } else if ($dados["tipoEntrada"] === "2"){
                        $entrada = "{$dados["data"]} {$dados["hora"]}";
                        $idalmoco = "S";
                        $tipo = "E";
                    } else if ($dados["tipoEntrada"] === "3") {
                        $saida = "{$dados["data"]} {$dados["hora"]}";
                        $idalmoco = "S";
                        $tipo = "S";
                    } else if ($dados["tipoEntrada"] === "4"){
                        $saida = "{$dados["data"]} {$dados["hora"]}";
                        $idalmoco = "N";
                        $tipo = "S";
                    }
                    
                    $lastEntry = $this->ApontamentoFactory->lastEntry($dados["funcionario"]);
                    
                    if (!empty($lastEntry)) {
                      $dateEntry = $lastEntry[0]['DTHRENTRADA'];
                    } else {
                      $dateEntry = null;
                    }
                     
                     $dadosInsertRegistro = array(
                        "NRREGISTROHORAS" => $codRegistroHoras, 
                        "NRAPONTAMENTO" => $nrApontamento,
                        "DTHRENTRADA" => $entrada,
                        "DTHRSAIDA" => $saida,
                        "HRTEMPOREGISTRO" => ($tipo === 'S') ? null: 0,
                        "IDTIPORESGISTRO" => $tipo, 
                        "IDALMOCO" => $idalmoco,
                        "NRORG" => $NRORG, 
                        "IDATIVO" => "S",
                        "DTINCLUSAO" => $dados["data"],
                        "DATEENTRY"      => $dateEntry
                    );

                    $this->ApontamentoFactory->insertRegistroHoras($dadosInsertRegistro);
                     
                }
                else {
                    
                    $entrada = "";
                    $saida = "";
                    $idalmoco = "";
                    $tipo = "";
                    $nrRegistrosHoras = $dados["name"];
                    
                    if ($dados["tipoEntrada"] === "1") {
                        $entrada = "{$dados["data"]} {$dados["hora"]}";
                        $idalmoco = "N";
                        $tipo = "E";
                    } else if ($dados["tipoEntrada"] === "2"){
                        $entrada = "{$dados["data"]} {$dados["hora"]}";
                        $idalmoco = "S";
                        $tipo = "E";
                    } else if ($dados["tipoEntrada"] === "3") {
                        $saida = "{$dados["data"]} {$dados["hora"]}";
                        $idalmoco = "S";
                        $tipo = "S";
                    } else if ($dados["tipoEntrada"] === "4"){
                        $saida = "{$dados["data"]} {$dados["hora"]}";
                        $idalmoco = "N";
                        $tipo = "S";
                    }
                    
                    $lastEntry = $this->ApontamentoFactory->lastEntry($dados["funcionario"]);
                    
                    if (!empty($lastEntry)) {
                      $dateEntry = $lastEntry[0]['DTHRENTRADA'];
                    } else {
                      $dateEntry = null;
                    }
                    
                    $temRegistro = $this->ApontamentoFactory->verificaRegistroHoras($tipo, $nrRegistrosHoras);
                    
                    if (sizeof($temRegistro) === 0) {
                        
                        $dadosInsertRegistro = array(
                            "NRREGISTROHORAS" => $codRegistroHoras, 
                            "NRAPONTAMENTO" => $consultaApontamento[0]['NRAPONTAMENTO'],
                            "DTHRENTRADA" => $entrada,
                            "DTHRSAIDA" => $saida,
                            "HRTEMPOREGISTRO" => "", 
                            "IDTIPORESGISTRO" => $tipo, 
                            "IDALMOCO" => $idalmoco,
                            "NRORG" => $NRORG, 
                            "IDATIVO" => "S",
                            "DTINCLUSAO" => $dados["data"],
                            "DATEENTRY"      => $dateEntry
                        );

                        $this->ApontamentoFactory->insertRegistroHoras($dadosInsertRegistro);
                        
                    } else {
                        
                        if ($dados["tipoEntrada"] === "1") {
                            $entrada = "{$dados["data"]} {$dados["hora"]}";
                            $idalmoco = "N";
                            $tipo = "E";
                        } else if ($dados["tipoEntrada"] === "2"){
                            $entrada = "{$dados["data"]} {$dados["hora"]}";
                            $idalmoco = "S";
                            $tipo = "E";
                        } else if ($dados["tipoEntrada"] === "3") {
                            $saida = "{$dados["data"]} {$dados["hora"]}";
                            $idalmoco = "S";
                            $tipo = "S";
                        } else if ($dados["tipoEntrada"] === "4"){
                            $saida = "{$dados["data"]} {$dados["hora"]}";
                            $idalmoco = "N";
                            $tipo = "S";
                        }
                        
                        $lastEntry = $this->ApontamentoFactory->lastEntry($dados["funcionario"]);
                    
                        if (!empty($lastEntry)) {
                          $dateEntry = $lastEntry[0]['DTHRENTRADA'];
                        } else {
                          $dateEntry = null;
                        }
                            
                        $paramentroDeleteREgistro = array(
                          "NRREGISTROHORAS" => $temRegistro[0]["NRREGISTROHORAS"],
                        );
                        
                        $this->ApontamentoFactory->deleteRegistroHoras($paramentroDeleteREgistro);
                        
                        $dadosInsertRegistro = array(
                            "NRREGISTROHORAS" => $codRegistroHoras, 
                            "NRAPONTAMENTO" => $temRegistro[0]["NRAPONTAMENTO"],
                            "DTHRENTRADA" => $entrada,
                            "DTHRSAIDA" => $saida,
                            "HRTEMPOREGISTRO" => "", 
                            "IDTIPORESGISTRO" => $tipo, 
                            "IDALMOCO" => $idalmoco,
                            "NRORG" => $NRORG, 
                            "IDATIVO" => "S",
                            "DTINCLUSAO" => $dados["data"],
                            "DATEENTRY"      => $dateEntry
                        );
                        

                        $this->ApontamentoFactory->insertRegistroHoras($dadosInsertRegistro);
                    }
                }
            }
            
            $response = "OK";
            
        }
        catch(\Exception $e) {
             $response = $e->getMessage();
        }
        return $response;
    }
    
    public function deleteRegistroHoras($param) {
        try {
            
            $data = $param['objeto']['data'];
            
            $quantidadeRegistrosDeHora = $this->ApontamentoFactory->quantidadeDeRegistros($data);
            
            $paramentroDeleteRegisto = array(
                "NRREGISTROHORAS" => $param['objeto']['name']
            );

            if ($quantidadeRegistrosDeHora[0]["QUANTIDIDADE"] == 1){

                $this->ApontamentoFactory->deleteRegistroHoras($paramentroDeleteRegisto);
                
                $paramentroDeleteApontamento = array(
                    "NRAPONTAMENTO" => $quantidadeRegistrosDeHora[0]["NRAPONTAMENTO"]
                );

                $this->ApontamentoFactory->deleteApontamento($paramentroDeleteApontamento);
                
            }
            else {
                $this->ApontamentoFactory->deleteRegistroHoras($paramentroDeleteRegisto);
            }
            
            $response = "DELETADO";
        }
        catch(\Exception $e) {
             $response = $e->getMessage();
        }
        
        return $response;
        
    }
    
    public function apurarHoras($param) {
        try {
            
            $paramentroConsultaApontamento = array(
              "DTAPONTAMENTO" => $param[0]["DATA"],
              "NRFUNCIONARIO" => $param[0]["NRFUNCIONARIO"]
            );
                    
            $consultaApontamento = $this->ApontamentoFactory->consultaApontamentoDia($paramentroConsultaApontamento);
    
            $parametroApuracao = array(
                "NRAPONTAMENTO" => $consultaApontamento[0]["NRAPONTAMENTO"],
                "NRFUNCIONARIO" => $param[0]["NRFUNCIONARIO"],
                "HRENTRADA" => trim($param[0]["HRENTRADA"]),
                "HRSAIDA" => trim($param[0]["HRSAIDA"]),
                "HRINTERVALO" => trim($param[0]["HRINTERVALO"]),
                "HRTRABALHADAS" => trim($param[0]["HRTRABALHADAS"]),
                "HRAUSENCIA" => trim($param[0]["HRAUSENCIA"]),
                "HRTOTAIS" => trim($param[0]["HRTOTAIS"]),
                "IDFALTA" => $param[0]["IDFALTA"],
                "IDAPURADO" => $param[0]["IDAPURADO"]
            );

            $this->ApontamentoFactory->apurarHoras($parametroApuracao);
            $response = "APURADO";

        } catch(\Exception $e) {
             $response = $e->getMessage();
        }
        return $response;
    }
}
?>