import { ComponentRender, IComponentEvents } from '@zeedhi/common';
import { IEventParam } from '@zeedhi/core';
import { ICalendar } from './ICalendar';

export class CalendarClass extends ComponentRender implements ICalendar {
  public events!: IComponentEvents<IEventParam<any>>;

  public type: string = 'day';

  public value!: string;

  public startPeriod?: string;

  public endPeriod?: string;

  public eventos: Array<Object> = [];

  constructor(props: ICalendar) {
    super(props);
    this.createAccessors();
  }

  public change() {
    if (this.events.change && typeof this.events.change === 'function') {
      this.events.change({ component: this });
    }
  }

  public clickOnEvent(evento: any) {
    if (this.events.clickOnEvent && typeof this.events.clickOnEvent === 'function') {
      this.events.clickOnEvent(evento);
    }
  }
}
